明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1021|回复: 3

在cad中写文字的问题

[复制链接]
发表于 2011-7-25 17:05:14 | 显示全部楼层 |阅读模式
如何用vba在cad写文字时加上下划线,还有怎么批量提取多条首尾相连的多段线的长度,最好能导入到excel中。求高手指教,谢谢
发表于 2011-7-31 10:58:56 | 显示全部楼层
获取多段线xyz 的坐标并存在一个txt文档里,改改就好       
        Private Sub GetLWPOLYLINECoordinates()
            Dim ss_dim As AcadSelectionSet, ent As AcadLWPolyline
            Dim dxf_code() As Integer, dxf_value() As Variant
            Dim i As Long, j As Long
            Dim dbCor As Variant, x As Double, y As Double, z As Double
            
            Set ss_dim = ThisDrawing.SelectionSets.Add("ssLine1")
            ReDim dxf_code(0), dxf_value(0)
            dxf_code(0) = 0: dxf_value(0) = "LWPOLYLINE"
            ss_dim.Select acSelectionSetAll, , , dxf_code, dxf_value
            
            Open "d:\aaaaa.txt" For Append As #1
            
            For Each ent In ss_dim
                For j = 0 To UBound(ent.Coordinates) \ 2
                    x = ent.Coordinates(j * 2)
                    y = ent.Coordinates(j * 2 + 1)
                    Print #1, "X" & x & ",Y" & y
                Next
            Next
            Close #1
            ss_dim.Clear
            ss_dim.Delete
        End Sub
发表于 2011-7-31 11:10:19 | 显示全部楼层
为文字添加下划线方法有二,可以用多行文字 编辑文字样式。也可以得到单行文字插入点并在相应位置直接画直线。
第一种简单,第二种方法我认为比较灵活
发表于 2011-9-19 17:04:19 | 显示全部楼层
把linlq986的程序修改一下,就可以求长度了
        Private Sub GetLWPOLYLINECoordinates()
             Dim ss_dim As AcadSelectionSet, ent As AcadLWPolyline
             Dim dxf_code() As Integer, dxf_value() As Variant
             Dim i As Long, j As Long
             Dim dbCor As Variant, x As Double, y As Double, z As Double
             Dim lLen as long
             Dim lLenAll as Long
             Set ss_dim = ThisDrawing.SelectionSets.Add("ssLine1")
             ReDim dxf_code(0), dxf_value(0)
             dxf_code(0) = 0: dxf_value(0) = "LWPOLYLINE"
             ss_dim.Select acSelectionSetAll, , , dxf_code, dxf_value
            
             Open "d:\aaaaa.txt" For Append As #1
            
             For Each ent In ss_dim
                 For j = 0 To UBound(ent.Coordinates) \ 2
                     x = ent.Coordinates(j * 2)
                     y = ent.Coordinates(j * 2 + 1)
                     Print #1, "X" & x & ",Y" & y
'                    以下是添加的内容
             lLen=ent.Length
                     Print #1, "lLen" & lLen
                     lLenAll=lLenAll+lLen
                     Print #1, "lLenAll" & lLenAll
                 Next
             Next
             Close #1
             ss_dim.Clear
             ss_dim.Delete
         End Sub
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 19:38 , Processed in 0.158373 second(s), 24 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表